#ifndef __LIS_SOLVERS_H__
#define __LIS_SOLVERS_H__

#include "lis_precon.h"
#include "lis_matvec.h"

#ifdef __cplusplus
extern "C"
{
#endif

	/****************************/
	/* SOLVER                   */
	/****************************/
		extern int lis_cg       (LIS_VECTOR b, LIS_VECTOR x, LIS_VECTOR work[], LIS_SCALAR params[], int options[], LIS_MATRIX A, LIS_PRECON M, LIS_SCALAR status[]);
		extern int lis_bicg     (LIS_VECTOR b, LIS_VECTOR x, LIS_VECTOR work[], LIS_SCALAR params[], int options[], LIS_MATRIX A, LIS_MATRIX At, LIS_PRECON M, LIS_SCALAR status[]);
		extern int lis_cgs      (LIS_VECTOR b, LIS_VECTOR x, LIS_VECTOR work[], LIS_SCALAR params[], int options[], LIS_MATRIX A, LIS_PRECON M, LIS_SCALAR status[]);
		extern int lis_bicgstab (LIS_VECTOR b, LIS_VECTOR x, LIS_VECTOR work[], LIS_SCALAR params[], int options[], LIS_MATRIX A, LIS_PRECON M, LIS_SCALAR status[]);
		extern int lis_bicgstabl(LIS_VECTOR b, LIS_VECTOR x, LIS_VECTOR work[], LIS_SCALAR params[], int options[], LIS_MATRIX A, LIS_PRECON M, LIS_SCALAR status[]);
		extern int lis_gpbicg   (LIS_VECTOR b, LIS_VECTOR x, LIS_VECTOR work[], LIS_SCALAR params[], int options[], LIS_MATRIX A, LIS_PRECON M, LIS_SCALAR status[]);
		extern int lis_gmres    (LIS_VECTOR b, LIS_VECTOR x, LIS_VECTOR work[], LIS_SCALAR params[], int options[], LIS_MATRIX A, LIS_PRECON M, LIS_SCALAR status[]);
		extern int lis_orthomin (LIS_VECTOR b, LIS_VECTOR x, LIS_VECTOR work[], LIS_SCALAR params[], int options[], LIS_MATRIX A, LIS_PRECON M, LIS_SCALAR status[]);
		extern int lis_qmr      (LIS_VECTOR b, LIS_VECTOR x, LIS_VECTOR work[], LIS_SCALAR params[], int options[], LIS_MATRIX A, LIS_PRECON M, LIS_SCALAR status[]);
		extern int lis_jacobi   (LIS_VECTOR b, LIS_VECTOR x, LIS_VECTOR work[], LIS_SCALAR params[], int options[], LIS_MATRIX A, LIS_PRECON M, LIS_SCALAR status[]);
		extern int lis_gs       (LIS_VECTOR b, LIS_VECTOR x, LIS_VECTOR work[], LIS_SCALAR params[], int options[], LIS_MATRIX A, LIS_PRECON M, LIS_SCALAR status[]);
		extern int lis_sor      (LIS_VECTOR b, LIS_VECTOR x, LIS_VECTOR work[], LIS_SCALAR params[], int options[], LIS_MATRIX A, LIS_PRECON M, LIS_SCALAR status[]);
	extern int lis_get_initial_residual(LIS_MATRIX A, LIS_PRECON M, LIS_VECTOR x, LIS_VECTOR b, LIS_VECTOR r, LIS_VECTOR t, LIS_SCALAR tol, LIS_SCALAR *bnrm2, LIS_SCALAR status[]);
#ifdef __cplusplus
}
#endif
#endif
